package zero1hd.rhythmbullet.ui.builders;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.scenes.scene2d.Actor;

import edu.emory.mathcs.jtransforms.fft.FloatFFT_1D;
import zero1hd.rhythmbullet.audio.CoreMusicInfo;

public class Visualizer extends Actor {
	private CoreMusicInfo cmi;
	private FloatFFT_1D fft;
	float[] audioPCM;
	
	public Visualizer() {
		fft = new FloatFFT_1D(cmi.getReadWindowSize());
		audioPCM = new float[cmi.getReadWindowSize()];
		
		setSize(Gdx.graphics.getHeight()*0.6f, Gdx.graphics.getHeight()*0.6f);
	}
	
	@Override
	public void act(float delta) {
		if (cmi.getPlaybackIndexPosition() > cmi.getCurrentReadWindowIndex()) {
			cmi.readSamples(audioPCM);
			Gdx.app.debug("Visualizer", "Skipping a frame to catch up to music.");
		} else {
			Gdx.app.debug("Visualizer", "Not reading so music can catch up.");
		}
		
		fft.realForward(audioPCM);
		super.act(delta);
	}
}
